﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Xaml;
using System.Xml;

using alib;
using alib.Debugging;
using alib.Enumerable;
using alib.String;
using alib.Wpf;

using Microsoft.Win32;
using Microsoft.WindowsAPICodePack.Dialogs;

namespace xigt.app
{
	public partial class main
	{
		protected override void OnKeyDown(KeyEventArgs e)
		{
			base.OnKeyDown(e);

			bool f_shift = (e.KeyboardDevice.Modifiers & ModifierKeys.Shift) != 0;

			switch (e.KeyboardDevice.Modifiers)
			{
				case ModifierKeys.Control:
					e.Handled = keypress_ctrl(e.Key, f_shift);
					break;

				case ModifierKeys.Alt:
					e.Handled = keypress_alt(e.Key, f_shift);
					break;

				default:
					e.Handled = keypress(e.Key, f_shift);
					break;
			}
		}

		///////////////////////////////////////////////////////////////////////////////////////
		/// 
		bool keypress(Key key, bool f_shift)
		{
			switch (key)
			{
				default:
					Debug.Print("Unhandled {0} keypress", key);
					return false;

				case Key.Escape:
					if (!Settings.Instance.EscapeKeyExit)
						return false;
					Close();
					break;

				case Key.Insert:
					NewCorpus();
					break;

				case Key.Delete:
					CloseFile();
					break;
			}
			return true;
		}

		bool keypress_ctrl(Key key, bool f_shift)
		{
			switch (key)
			{
				default:
					Debug.Print("Unhandled ctrl+{0} keypress", key);
					return false;

				case Key.F:
					w_find.SelectAll();
					w_find.Focus();
					break;

				case Key.N:
					NewCorpus();
					break;

				case Key.O:
					OpenFile();
					break;

				case Key.S:
					SaveFile();
					break;

				case Key.F4:
					CloseFile();
					break;
			}
			return true;
		}

		bool keypress_alt(Key key, bool f_shift)
		{
			switch (key)
			{
				default:
					Debug.Print("Unhandled alt+{0} keypress", key);
					return false;
			}
			return true;
		}
	};
}