﻿using System;
using System.Collections;
using System.Diagnostics;
using System.ComponentModel;
using System.Collections.Specialized;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using xigt.app;

using alib;
using alib.Debugging;
using alib.Enumerable;
using alib.Wpf;

namespace xigt.ui
{
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/// 
	public partial class corpora_ctrl : ListView
	{
		public corpora_ctrl()
		{
			InitializeComponent();

			//var list = Settings.Instance.CorporaColumnDisplayInfo;

//			Loaded += (o, e) =>
//			{
//#if false
//				((corpora_ctrl)o).View.EnsureColumnOrder(list);
//#endif
//				((corpora_ctrl)o)._set_selected_item();
//			};
		}

		//public new CorporaGridView View { get { return (CorporaGridView)base.View; } }
	

#if true
		void fm_Click(Object sender, RoutedEventArgs e)
		{
			var mi = sender as MenuItem;
			var item = mi.DataContext as xigt_corpus;
			if (item == null)
			{
				//w_opened.SetCurrentValue(TextBlock.TextProperty, "No item selected.");
				return;
			}
			String filename = item.FullPath;
			//int ix;

			switch (mi.Name)
			{
#if OLD
				case "fm_save":
					item.SaveOldXaml();
					w_opened.SetCurrentValue(TextBlock.TextProperty, String.Format("saved changes to file '{0}'.", filename));
					break;

				case "fm_save_close":
					item.SaveOldXaml();
					if ((ix = ContextElements.IndexOf(item)) != -1)
					{
						ccc.RemoveAt(ix);
						while (ix >= ContextElements.Count)
							ix--;
						w_corpora.SelectedIndex = ix;
					}
					w_opened.SetCurrentValue(TextBlock.TextProperty, String.Format("saved changes and closed file '{0}'.", filename));
					break;

				case "fm_revert":
					{
						var _new = open_old_xaml_file_inner(filename);
						if ((ix = ContextElements.IndexOf(item)) != -1)
							ContextElements[ix] = _new;
						w_corpora.SelectedIndex = ix;
						w_opened.SetCurrentValue(TextBlock.TextProperty, String.Format("reverted file '{0}'.", filename));
					}
					break;

				case "fm_close":
					if ((ix = ItemsSource.IndexOf(item)) != -1)
					{
						ItemsSource.RemoveAt(ix);
						while (ix >= ItemsSource.Count)
							ix--;
						SelectedIndex = ix;
					}
					break;
#else
				default:
					throw new Exception();
#endif
			}
		}
#endif
	};

	public class CorporaGridView : GridView
	{
		public static readonly DependencyProperty ColumnDisplayInfoProperty =
			DependencyProperty.RegisterAttached("ColumnDisplayInfo", typeof(ColumnDisplayInfo), typeof(CorporaGridView), new FrameworkPropertyMetadata(null));

		public static ColumnDisplayInfo GetColumnDisplayInfo(DependencyObject obj) { return (ColumnDisplayInfo)obj.GetValue(ColumnDisplayInfoProperty); }
		public static void SetColumnDisplayInfo(DependencyObject obj, ColumnDisplayInfo value) { obj.SetValue(ColumnDisplayInfoProperty, value); }

		static readonly DependencyPropertyKey TotalWidthPropertyKey =
			DependencyProperty.RegisterReadOnly("TotalWidth", typeof(Double), typeof(GridViewColumnDisplayInfo), new FrameworkPropertyMetadata(0.0,
				(o, e) =>
				{
					//Debug.Print("act: {0}", (Double)e.NewValue);
				},
				(d, _) =>
				{
					var l = ((CorporaGridView)d).Columns;
					Double w = 0.0;
					for (int i = 0; i < l.Count; i++)
						w += l[i].ActualWidth;
					return w;
				}));

		public void InvalidateTotalColumnWidth() { CoerceValue(TotalWidthPropertyKey.DependencyProperty); }

		[DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public Double TotalWidth { get { return (Double)GetValue(TotalWidthPropertyKey.DependencyProperty); } }

		public CorporaGridView()
		{
			AllowsColumnReorder = true;
		}

		public corpora_ctrl Owner { get; set; }

#if false
		public void EnsureColumnOrder(GridViewColumnDisplayInfo list)
		{
			int i, c;
			if ((c = Columns.Count) != list.Count)
				throw new Exception("error");

			//if (bbb != null)
			//	throw not.expected;
			//bbb = new Binding
			//{
			//	Source = list,
			//	Path = new PropertyPath(GridViewColumnDisplayInfo.ColumnWidthTotalProperty),
			//	Mode = BindingMode.OneWay,
			//	NotifyOnSourceUpdated = true,
			//};

			//Binding.AddSourceUpdatedHandler(this, new EventHandler<DataTransferEventArgs>(foo));

			ColumnDisplayInfo cdi;
			GridViewColumn gvc;

			for (i = 0; i < c; i++)
			{
				cdi = GetColumnDisplayInfo(gvc = Columns[i]);

				//cdi.Width = gvc.ActualWidth;
				//gvc.Width = cdi.Width;

				if (cdi != list[i])
					Nop.X();
			}
			Nop.X();
		}
#endif

		void Columns_CollectionChanged(Object sender, NotifyCollectionChangedEventArgs e)
		{
			int i, ix;
			var list = Settings.Instance.CorporaColumnDisplayInfo;
			Guid key;
			GridViewColumn gvc;
			ColumnDisplayInfo cdi;

			switch (e.Action)
			{
				case NotifyCollectionChangedAction.Reset:
					list.Clear();
					break;

				case NotifyCollectionChangedAction.Add:
					for (i = 0; i < e.NewItems.Count; i++)
					{
						if (GetColumnDisplayInfo(gvc = (GridViewColumn)e.NewItems[i]) != null)
							throw not.expected;

						key = ColumnDisplayInfo.GetKey(gvc);

						if ((ix = list.IndexOfFirst(x => x.Key == key)) < 0)
							list.Add(cdi = new ColumnDisplayInfo { Key = key, Width = gvc.Width });
						else
							gvc.Width = (cdi = list[ix]).Width;

						SetColumnDisplayInfo(gvc, cdi);

						BindingOperations.SetBinding(cdi, ColumnDisplayInfo.WidthProperty, new Binding
						{
							Source = gvc,
							Path = new PropertyPath("ActualWidth"),
							Mode = BindingMode.OneWay,
						});
					}
					break;

				default:
					throw new Exception(e.Action.ToString());
			}
		}
	};

	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/// 
	public class status_icon_selector : DataTemplateSelector
	{
		public override DataTemplate SelectTemplate(Object item, DependencyObject cp)
		{
			var fe = cp as FrameworkElement;
			return fe != null ? fe.FindResource(item) as DataTemplate : null;
		}
	};
}
