﻿using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using alib;
using alib.Debugging;
using alib.Enumerable;
using alib.Wpf;

namespace xigt.ui
{
	public partial class dep_items : TreeLayoutPanel
	{
		public dep_items()
		{
			InitializeComponent();
		}

		protected override void OnPropertyChanged(DependencyPropertyChangedEventArgs e)
		{
			base.OnPropertyChanged(e);

			tier tier;
			if (e.Property == DataContextProperty && (tier = e.NewValue as tier) != null)
			{
				Children.Clear();

				String hd, dp;

				var refs = new List<String>();
				foreach (var item in tier)
				{
					if ((dp = item.dep).Length > 0 && !refs.Contains(dp))
						refs.Add(dp);
					if ((hd = item.head).Length > 0 && !refs.Contains(hd))
						refs.Add(hd);
				}

				var smap = new Dictionary<String, FrameworkElement>();
				var igt = tier.GetIgt();
				var dt = (DataTemplate)Resources["dt_item"];

				foreach (var sref in refs)
				{
					IElem ie;
					if (!igt.igt_names.TryGetValue(sref, out ie))
						continue;

					var el = (FrameworkElement)dt.LoadContent();
					el.DataContext = ie;
					Children.Add(el);

					smap.Add(sref, el);
				}

				foreach (var item in tier)
				{
					if ((dp = item.dep).Length > 0 && (hd = item.head).Length > 0)
					{
						SetTreeParent(smap[dp], smap[hd]);
						
						SetLinkText(smap[dp], item.id);
					}
				}

				//Debug.Print("{0} {1} {2}", item.id, item.dep, item.head);

				//Debug.WriteLine("================");
			}
		}
	};
}
