﻿using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using alib;
using alib.Debugging;
using alib.Enumerable;
using alib.Wpf;

namespace xigt.ui
{
	public partial class PsItems : ItemsControl
	{
		public PsItems()
		{
			InitializeComponent();
		}

		protected override void PrepareContainerForItemOverride(DependencyObject _cp, Object _it)
		{
			var cp = (ContentPresenter)_cp;
			var it = (item)_it;

			base.PrepareContainerForItemOverride(cp, it);

			ContentPresenter el;
			if (it.parent != null)
			{
				if ((el = (ContentPresenter)ItemContainerGenerator.ContainerFromItem(it.parent)) != null)
					cp.SetValue(TreeLayoutPanel.TreeParentProperty, el);
			}

			foreach (var it_child in it.Host.Where(x => x.parent == it))
			{
				if ((el = (ContentPresenter)ItemContainerGenerator.ContainerFromItem(it_child)) != null)
					el.SetValue(TreeLayoutPanel.TreeParentProperty, cp);
			}
		}

		protected override void ClearContainerForItemOverride(DependencyObject _cp, Object _it)
		{
			var cp = (ContentPresenter)_cp;
			var it = (item)_it;

			base.ClearContainerForItemOverride(cp, it);

			cp.ClearValue(TreeLayoutPanel.TreeParentProperty);
		}
	};

	public class PsItemTemplateSelector : DataTemplateSelector
	{
		public static readonly PsItemTemplateSelector Instance = new PsItemTemplateSelector();

		//public override DataTemplate SelectTemplate(Object item, ItemsControl ctrl)
		//{
		//	return (ItemContainerTemplate)ctrl.Resources["node_template"];
		//}

		public override DataTemplate SelectTemplate(object _it, DependencyObject _cp)
		{
			item it;
			if ((it = _it as item) == null)
				return null;

			var ctrl = _cp.FindAncestor<ItemsControl>();

			String key;
			switch (it.Mode)
			{
				case item_mode.Align:
				case item_mode.Annotation:
					key = "leaf_template";
					break;
				case item_mode.Source:
					return null;
					break;
				case item_mode.PSNode:
					key = "node_template";
					break;
				default:
					throw not.impl;
			}

			//Debug.Print("{0}\t{1}", it.id, it.Mode);

			//return base.SelectTemplate(_it, _cp);
			return (ItemContainerTemplate)ctrl.Resources[key];
		}
	};


	public class PsTree : TreeLayoutPanel
	{
		//protected override void OnPropertyChanged(DependencyPropertyChangedEventArgs e)
		//{
		//	base.OnPropertyChanged(e);

		//	if (e.Property == DataContextProperty)
		//	{
		//		Children.Clear();

		//		foreach (var item in DataContext)
		//		{

		//			Children.Add(item);
		//		}
		//		Nop.X();
		//	}
		//}

		new tier DataContext { get { return base.DataContext as tier; } }

		protected override void OnVisualChildrenChanged(DependencyObject _add, DependencyObject _del)
		{
			base.OnVisualChildrenChanged(_add, _del);

			//var cc = this.FindAncestor<ItemsControl>();
			//var icg = cc.ItemContainerGenerator;

			//foreach (FrameworkElement el in InternalChildren)
			//{
			//	var it = (item)((FrameworkElement)el).DataContext;

			//	if (it.parent != null)
			//	{
			//		var par = (FrameworkElement)icg.ContainerFromItem(it.parent);
			//		SetTreeParent(el, par);
			//	}
			//}
		}

		//protected override Size ArrangeOverride(Size sz)
		//{
		//	return base.ArrangeOverride(sz);
		//}
	};
}
