﻿using System;
using System.Diagnostics;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using alib;
using alib.Debugging;
using alib.Enumerable;
using alib.Wpf;
using alib.String;

namespace xigt.ui
{
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/// 
	public partial class _align_ref : Border
	{
		public _align_ref()
		{
			InitializeComponent();
		}

		protected override void OnMouseRightButtonDown(MouseButtonEventArgs e)
		{
			base.OnMouseRightButtonDown(e);

			var cm = new ContextMenu();

			if (DataContext is item)
			{
				var it = (item)DataContext;
				var align_cur = it.GetIgt().igt_names[it.alignment];

				foreach (var x in it.Host.alignment)
				{
					var mi = new MenuItem
					{
						Header = new TextBlock
						{
							Inlines =
							{
								new Run(x.id) { FontWeight = FontWeights.SemiBold },
								new Run("\t│" + x.Text + "│"),
							},
						},
						IsCheckable = true,
						IsChecked = x == align_cur,
					};
					mi.Checked += (o, ee) =>
					{
						it.alignment = x.id;
					};
					cm.Items.Add(mi);
				}
			}
			this.ContextMenu = cm;
		}

#if TREF
		protected override void OnMouseEnter(MouseEventArgs e)
		{
			tref r;
			if ((r = DataContext as tref) != null)
				IgtControl.HoveredRef = r.RefExpr;
		}

		protected override void OnMouseLeave(MouseEventArgs e)
		{
			IgtControl.HoveredRef = default(RefExpr);
		}
#endif
	};
}
