﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using alib;
using alib.Debugging;
using alib.Enumerable;
using alib.Wpf;

namespace xigt.ui.tier_types
{
	public abstract class _tier_type_stack_base : StackPanel
	{
		public _tier_type_stack_base()
		{
			this.Margin = new Thickness(4, 4, 0, 0);
		}

		protected override void OnIsItemsHostChanged(bool _old, bool _new)
		{
			base.OnIsItemsHostChanged(_old, _new);
			if (_new)
				this.FindAncestor<Border>().Background = this.Background;
		}
	};

	public abstract class _tier_type_hstack_base : _tier_type_stack_base
	{
		public _tier_type_hstack_base()
		{
			this.Orientation = Orientation.Horizontal;
		}
	};

	public abstract class _tier_type_vstack_base : _tier_type_stack_base
	{
		public _tier_type_vstack_base()
		{
			this.Orientation = Orientation.Vertical;
		}
	};

	public class odin : _tier_type_vstack_base
	{
		public odin()
		{
			this.Background = SolidColorBrushCache.Get(0xFFFFD0);
		}
	};

	public class odin_raw : odin
	{
	};

	public class odin_cleaned : odin
	{
	};

	public class odin_normalized : odin
	{
	};

	public class translations : _tier_type_vstack_base
	{
		public translations()
		{
			this.Background = SolidColorBrushCache.Get(0xFFD0E0);
		}
	};

	public class phrases : _tier_type_hstack_base
	{
		public phrases()
		{
			this.Background = SolidColorBrushCache.Get(0xD0FFFF);
		}
	};

	public class words : _tier_type_hstack_base
	{
		public words()
		{
			this.Background = SolidColorBrushCache.Get(0xFFFFE0);
		}
	};

	public class morphemes : _tier_type_hstack_base
	{
		public morphemes()
		{
			this.Background = SolidColorBrushCache.Get(0xFFE0FF);
		}
	};

	public class glosses : _tier_type_hstack_base
	{
		public glosses()
		{
			this.Background = SolidColorBrushCache.Get(0xE0FFFF);
		}
	};

	public class translation_words : _tier_type_hstack_base
	{
		public translation_words()
		{
			this.Background = SolidColorBrushCache.Get(0xD0E0FF);
		}
	};

	public class bilingual_alignments : _tier_type_hstack_base
	{
		public bilingual_alignments()
		{
			this.Background = SolidColorBrushCache.Get(0xE0FFD0);
		}
	};

	public class tokenization : _tier_type_hstack_base
	{
		public tokenization()
		{
			this.Background = SolidColorBrushCache.Get(0xD0FFE0);
		}
	};

	public class pos : _tier_type_hstack_base
	{
		public pos()
		{
			this.Background = SolidColorBrushCache.Get(0xFFE0D0);
		}
	};


#if false
0xFFFFD0
0xFFD0FF
0xD0FFFF
0xFFFFE0
0xFFE0FF
0xE0FFFF
0xFFD0E0
0xD0E0FF
0xE0FFD0
0xD0FFE0
0xFFE0D0
0xE0D0FF

0xD0D0D0
0xE0E0E0
0xD0E0D0
0XE0D0E0


#endif
}