﻿#if OLD_REFS

using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Windows;
using System.Windows.Media;
using System.Windows.Markup;

using alib;
using alib.Debugging;
using alib.Enumerable;

namespace xigt
{
	public class tref : DependencyObject//, IEquatable<tref>
	{
		public static tref Get(tref prev, String delim, item item, int i0, int i1)
		{
			if (item == null)
				throw not.valid;
			if (i1 < i0)
				throw not.valid;

			//if ((i0 == -1) != (i1 == -1))
			//	Nop.X();

			if (prev == null)
			{
				if (delim != null)
					throw not.valid;

				//if (i0 < 0 && i1 < 0)
				//	return item;

				if ((i0 < 0) != (i1 < 0))
					throw not.valid;

				var z = new tref { TargetItem = item, Start = i0, End = i1 };

				return z;
			}
			if (delim == null)
				throw not.valid;

			return new ItemRefJoin { LeftArg = prev, Delimter = delim, TargetItem = item, Start = i0, End = i1 };
		}

		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		/// 
		public static readonly DependencyProperty TargetItemProperty =
			DependencyProperty.Register("TargetItem", typeof(item), typeof(tref), new PropertyMetadata(null,
				(o, e) =>
				{
					((tref)o).InvalidateProperty(RefExprProperty);
				}));

		public item TargetItem
		{
			[DebuggerStepThrough]
			get { return (item)GetValue(TargetItemProperty); }
			set { SetValue(TargetItemProperty, value); }
		}

		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		/// 
		public static readonly DependencyProperty StartProperty =
			DependencyProperty.Register("Start", typeof(int), typeof(tref), new PropertyMetadata(-1,
				(o, e) => ((tref)o).InvalidateProperty(RefExprProperty),
				(d, o) => ((tref)d)._coerce_start((int)o)));

		int _coerce_start(int _start)
		{
			int _end, c;

			if (_start < 0)
				return -1;

			if ((_end = End) >= 0 && _start > _end)
				_start = _end;

			if (TargetItem != null && TargetItem.content != null && _start > (c = TargetItem.content.Text.Length))
				_start = c;

			return _start;
		}

		public int Start
		{
			[DebuggerStepThrough]
			get { return (int)GetValue(StartProperty); }
			set { SetValue(StartProperty, value); }
		}

		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		/// 
		public static readonly DependencyProperty EndProperty =
			DependencyProperty.Register("End", typeof(int), typeof(tref), new PropertyMetadata(-1,
				(o, e) => ((tref)o).InvalidateProperty(RefExprProperty),
				(d, o) => ((tref)d)._coerce_end((int)o)));

		int _coerce_end(int _end)
		{
			int _start, c;

			if (_end < 0)
				return -1;

			if ((_start = Start) >= 0 && _end < _start)
				_end = _start;

			if (TargetItem != null && TargetItem.content != null && _end > (c = TargetItem.content.Text.Length))
				_end = c;

			return _end;
		}

		public int End
		{
			[DebuggerStepThrough]
			get { return (int)GetValue(EndProperty); }
			set { SetValue(EndProperty, value); }
		}

		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		/// 
		public static DependencyProperty RefExprProperty { get { return RefExprPropertyKey.DependencyProperty; } }

		public static readonly DependencyPropertyKey RefExprPropertyKey =
			DependencyProperty.RegisterReadOnly("RefExpr", typeof(String), typeof(tref), new PropertyMetadata(default(String),
				(o, e) => ((tref)o).InvalidateProperty(TextProperty),
				(d, _) => ((tref)d)._coerce_expr()));

		String _coerce_expr()
		{
			item item;
			int _start, _end;

			if ((item = this.TargetItem) == null)
				return null;

			var s = item.id;

			if ((_start = Start) >= 0 && (_end = End) >= 0)
				s += "[" + _start + ":" + _end + "]";

			return s;
		}

		public String RefExpr
		{
			[DebuggerStepThrough]
			get { return (String)GetValue(RefExprProperty); }
		}

		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		/// 
		public static DependencyProperty TextProperty =
			DependencyProperty.Register("Text", typeof(String), typeof(tref), new PropertyMetadata(String.Empty,
				null,
				(d, o) => ((tref)d)._coerce_text((String)o)));

		String _coerce_text(String q)
		{
			String s;
#if false
			s = q;
#else
			int c, _start, _end;

			//if (Item == null || (_start = Start) < 0 || (_end = End) < 0 || (c = (s = Item.content.Text).Length) == 0)
			//	return q ?? String.Empty;

			if (q == null)
				q = String.Empty;

			tref tro;
			if (TargetItem == null || (tro = TargetItem.content) == null)
				return q;

			if ((c = (s = tro.Text).Length) == 0)
				return q;

			if ((_start = Start) < 0 || (_end = End) < 0)
				return s;

			if (_end > c)
				_end = c;

			if ((uint)c > (uint)(c = _end - _start))
			{
				//Debug.Print("{0,3} {1,3} [{2}] [{3}]", _start, _end, Item.Text, s.Substring(_start, c));

				return s.Substring(_start, c);
			}
#endif
			return s;
		}

		public String Text
		{
			[DebuggerStepThrough]
			get { return (String)this.GetValue(TextProperty); }
			set { this.SetValue(TextProperty, value); }
		}

		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		/// 
		//bool IEquatable<tref>.Equals(tref other) { return _itr_equals(other); }

		//protected virtual bool _itr_equals(tref other)
		//{
		//	if ((Object)this == (Object)other)
		//		return true;

		//	if ((Object)other == null)
		//		return false;

		//	return (Object)TargetItem == (Object)other.TargetItem && Start == other.Start && End == other.End;
		//}

		//public override String ToString()
		//{
		//	return RefExpr;
		//}
	};

	public sealed class ItemRefJoin : tref
	{
		public static readonly DependencyProperty DelimterProperty =
			DependencyProperty.Register("Delimiter", typeof(String), typeof(ItemRefJoin), new PropertyMetadata(null,
				(o, e) => ((ItemRefJoin)o).CoerceValue(RefExprProperty)));

		public String Delimter
		{
			[DebuggerStepThrough]
			get { return (String)GetValue(DelimterProperty); }
			set { SetValue(DelimterProperty, value); }
		}

		public static readonly DependencyProperty LeftArgProperty =
			DependencyProperty.Register("LeftArg", typeof(tref), typeof(ItemRefJoin), new PropertyMetadata(null,
				(o, e) => ((ItemRefJoin)o).CoerceValue(RefExprProperty)));

		public tref LeftArg
		{
			[DebuggerStepThrough]
			get { return (tref)GetValue(LeftArgProperty); }
			set { SetValue(LeftArgProperty, value); }
		}

		//protected override bool _itr_equals(tref other)
		//{
		//	throw not.impl;
		//	return base._itr_equals(other);
		//}
	};
}
#endif