﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Windows;
using System.Text;
using System.Windows.Markup;
using System.Threading;
using System.Threading.Tasks;
using System.Xaml;
using System.Xml;

using alib;
using alib.Debugging;
using alib.String;
using alib.Enumerable;

namespace xigt
{
	public class corpus_xmldoc : XmlDocument
	{
		[DebuggerStepThrough]
		public new _elem CreateElement(String name) { return (_elem)base.CreateElement(name); }

		public new xigt_corpus DocumentElement { [DebuggerStepThrough] get { return (xigt_corpus)base.DocumentElement; } }


		public override XmlElement CreateElement(String prefix, String name, String s_ns)
		{
			_elem elem;

			switch (name)
			{
				case "xigt-corpus":
					elem = new xigt_corpus(prefix, name, s_ns, this);
					break;

				case "igt":
					elem = new igt(prefix, name, s_ns, this);
					break;

				case "tier":
					elem = new tier(prefix, name, s_ns, this);
					break;

				//case "metadata":
				//	elem = new metadata(prefix, name, s_ns, this);
				//	break;

				//case "meta":
				//	elem = new meta(prefix, name, s_ns, this);
				//	break;

				case "item":
					elem = new item(prefix, name, s_ns, this);
					break;

				default:
					elem = new _elem(prefix, name, s_ns, this);
					break;

			}

			return elem;
		}
	};
}